Index: src/UIElements/TextUI/TextDialog.cpp
===================================================================
--- src/UIElements/TextUI/TextDialog.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/UIElements/TextUI/TextDialog.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * TextDialog.cpp
@@ -6,4 +13,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -19,13 +31,15 @@
 #include "World.hpp"
 #include "periodentafel.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 
 #include "atom.hpp"
 #include "element.hpp"
 #include "molecule.hpp"
-#include "vector.hpp"
-#include "Matrix.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 #include "Box.hpp"
+
+#include <boost/lexical_cast.hpp>
 
 using namespace std;
@@ -43,70 +57,69 @@
 }
 
-
-void TextDialog::queryEmpty(const char* title, string description){
+void TextDialog::queryEmpty(const char* title, std::string description){
   registerQuery(new EmptyTextQuery(title,description));
 }
 
-void TextDialog::queryBoolean(const char* title, string description){
+void TextDialog::queryBoolean(const char* title, std::string description){
   registerQuery(new BooleanTextQuery(title,description));
 }
 
-void TextDialog::queryInt(const char* title, string description){
+void TextDialog::queryInt(const char* title, std::string description){
   registerQuery(new IntTextQuery(title,description));
 }
 
-void TextDialog::queryInts(const char* title, string description){
+void TextDialog::queryInts(const char* title, std::string description){
   registerQuery(new IntsTextQuery(title,description));
 }
 
-void TextDialog::queryDouble(const char* title, string description){
+void TextDialog::queryDouble(const char* title, std::string description){
   registerQuery(new DoubleTextQuery(title,description));
 }
 
-void TextDialog::queryDoubles(const char* title, string description){
+void TextDialog::queryDoubles(const char* title, std::string description){
   registerQuery(new DoublesTextQuery(title,description));
 }
 
-void TextDialog::queryString(const char* title, string description){
+void TextDialog::queryString(const char* title, std::string description){
   registerQuery(new StringTextQuery(title,description));
 }
 
-void TextDialog::queryStrings(const char* title, string description){
+void TextDialog::queryStrings(const char* title, std::string description){
   registerQuery(new StringsTextQuery(title,description));
 }
 
-void TextDialog::queryAtom(const char* title, string description) {
+void TextDialog::queryAtom(const char* title, std::string description) {
   registerQuery(new AtomTextQuery(title,description));
 }
 
-void TextDialog::queryAtoms(const char* title, string description) {
+void TextDialog::queryAtoms(const char* title, std::string description) {
   registerQuery(new AtomsTextQuery(title,description));
 }
 
-void TextDialog::queryMolecule(const char* title, string description) {
+void TextDialog::queryMolecule(const char* title, std::string description) {
   registerQuery(new MoleculeTextQuery(title,description));
 }
 
-void TextDialog::queryMolecules(const char* title, string description) {
+void TextDialog::queryMolecules(const char* title, std::string description) {
   registerQuery(new MoleculesTextQuery(title,description));
 }
 
-void TextDialog::queryVector(const char* title, bool check, string description) {
+void TextDialog::queryVector(const char* title, bool check, std::string description) {
   registerQuery(new VectorTextQuery(title,check,description));
 }
 
-void TextDialog::queryVectors(const char* title, bool check, string description) {
+void TextDialog::queryVectors(const char* title, bool check, std::string description) {
   registerQuery(new VectorsTextQuery(title,check,description));
 }
 
-void TextDialog::queryBox(const char* title, string description) {
+void TextDialog::queryBox(const char* title, std::string description) {
   registerQuery(new BoxTextQuery(title,description));
 }
 
-void TextDialog::queryElement(const char* title, string description){
+void TextDialog::queryElement(const char* title, std::string description){
   registerQuery(new ElementTextQuery(title,description));
 }
 
-void TextDialog::queryElements(const char* title, string description){
+void TextDialog::queryElements(const char* title, std::string description){
   registerQuery(new ElementsTextQuery(title,description));
 }
@@ -160,5 +173,5 @@
   getline(cin,line);
   // dissect by " "
-  string::iterator olditer = line.begin();
+  std::string::iterator olditer = line.begin();
   for(string::iterator iter = line.begin(); iter != line.end(); ++iter) {
     if (*iter == ' ') {
@@ -229,5 +242,5 @@
   getline(cin,temp);
   // dissect by " "
-  string::iterator olditer = temp.begin();
+  std::string::iterator olditer = temp.begin();
   for(string::iterator iter = temp.begin(); iter != temp.end(); ++iter) {
     if (*iter == ' ') {
@@ -277,5 +290,5 @@
   getline(cin,line);
   // dissect by " "
-  string::iterator olditer = line.begin();
+  std::string::iterator olditer = line.begin();
   for(string::iterator iter = line.begin(); iter != line.end(); ++iter) {
     if (*iter == ' ') {
@@ -340,5 +353,5 @@
   getline(cin,line);
   // dissect by " "
-  string::iterator olditer = line.begin();
+  std::string::iterator olditer = line.begin();
   for(string::iterator iter = line.begin(); iter != line.end(); ++iter) {
     if (*iter == ' ') {
@@ -412,5 +425,5 @@
   getline(cin,line);
   // dissect by " "
-  string::iterator olditer = line.begin();
+  std::string::iterator olditer = line.begin();
   for(string::iterator iter = line.begin(); iter != line.end(); ++iter) {
     if (*iter == ' ') {
@@ -459,5 +472,5 @@
   double coord = 0.;
   int counter = 0;
-  string::iterator olditer = line.begin();
+  std::string::iterator olditer = line.begin();
   for(string::iterator iter = line.begin(); (iter != line.end()) && (counter != 3); ++iter) {
     if (*iter == ',') {
@@ -497,6 +510,6 @@
   // dissect by ","
   double coord = 0.;
-  string::iterator olditerspace = line.begin();
-  string::iterator olditercomma = line.begin();
+  std::string::iterator olditerspace = line.begin();
+  std::string::iterator olditercomma = line.begin();
   int counter = 0;
   for(string::iterator vectoriter = line.begin(); vectoriter != line.end(); ++vectoriter) {
@@ -523,4 +536,6 @@
     }
   }
+
+  return true;
 }
 
@@ -565,5 +580,5 @@
   bool badInput=false;
   bool aborted = false;
-  element * temp = NULL;
+  const element * temp = NULL;
   do{
     badInput = false;
@@ -592,6 +607,6 @@
     // Try to read as shorthand
     // the last buffer content was not removed, so we read the
-    // same thing again, this time as a string
-    string shorthand;
+    // same thing again, this time as a std::string
+    std::string shorthand;
     cin >> shorthand;
     if(!cin.fail()){
@@ -633,5 +648,5 @@
   getline(cin,line);
   // dissect by " "
-  string::iterator olditer = line.begin();
+  std::string::iterator olditer = line.begin();
   for(string::iterator iter = line.begin(); iter != line.end(); ++iter) {
     if (*iter == ' ') {
Index: src/UIElements/TextUI/TextStatusIndicator.cpp
===================================================================
--- src/UIElements/TextUI/TextStatusIndicator.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/UIElements/TextUI/TextStatusIndicator.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * TextStatusIndicator.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/TextUI/TextUIFactory.cpp
===================================================================
--- src/UIElements/TextUI/TextUIFactory.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/UIElements/TextUI/TextUIFactory.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * TextUIFactory.cpp
@@ -5,4 +12,11 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
 
 #include "UIElements/TextUI/TextUIFactory.hpp"
Index: src/UIElements/TextUI/TextWindow.cpp
===================================================================
--- src/UIElements/TextUI/TextWindow.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/UIElements/TextUI/TextWindow.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * TextWindow.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -25,9 +37,8 @@
 #include "Views/StreamStringView.hpp"
 #include "Views/MethodStringView.hpp"
-#include "Helpers/MemDebug.hpp"
 
 #include "defs.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 
 // all needed due to config::SaveAll()
@@ -45,4 +56,8 @@
 {
   map <std::string, TextMenu *> NametoTextMenuMap;
+  std::set <char> ShortcutList;
+  // reserve s for save and q for quite
+  ShortcutList.insert('s');
+  ShortcutList.insert('q');
 
   // populate all actions
@@ -57,19 +72,14 @@
   new SeperatorItem(main_menu);
 
-  Action* undoAction = ActionRegistry::getInstance().getActionByName("Undo");
-  new ActionMenuItem('u',"Undo last operation",main_menu,undoAction);
+  Action* undoAction = ActionRegistry::getInstance().getActionByName("undo");
+  new ActionMenuItem(getSuitableShortForm(ShortcutList,"Undo last operation"),"Undo last operation",main_menu,undoAction);
 
-  Action* redoAction = ActionRegistry::getInstance().getActionByName("Redo");
-  new ActionMenuItem('r',"Redo last operation",main_menu,redoAction);
+  Action* redoAction = ActionRegistry::getInstance().getActionByName("redo");
+  new ActionMenuItem(getSuitableShortForm(ShortcutList,"Redo last operation"),"Redo last operation",main_menu,redoAction);
 
   new SeperatorItem(main_menu);
 
-  Action *setMoleculeAction = new MethodAction("setMoleculeAction",boost::bind(&MoleculeListClass::flipChosen,World::getInstance().getMolecules()));
-  new ActionMenuItem('a',"set molecule (in)active",main_menu,setMoleculeAction);
-
-  TextMenu *Menu = NULL;
-  std::set <char> ShortcutList;
   for(map<std::string, pair<std::string,std::string> >::iterator iter = MapOfActions::getInstance().MenuDescription.begin(); iter != MapOfActions::getInstance().MenuDescription.end(); ++iter) {
-    Menu = new TextMenu(Log() << Verbose(0), iter->second.second);
+    TextMenu *Menu = new TextMenu(Log() << Verbose(0), iter->second.second);
     NametoTextMenuMap.insert( pair <std::string, TextMenu *> (iter->first, Menu) );
     new SubMenuItem(getSuitableShortForm(ShortcutList,iter->first),iter->second.first.c_str(),main_menu,Menu);
@@ -78,4 +88,5 @@
   new SeperatorItem(main_menu);
 
+  // save has reserved key 's'
   Action *saveConfigAction = ActionRegistry::getInstance().getActionByName("output");
   new ActionMenuItem('s',"save current setup to config files",main_menu,saveConfigAction);
@@ -84,9 +95,8 @@
   new ActionMenuItem('q',"quit",main_menu,quitAction);
 
+  // quit has reserved key 'q'
   // go through all menus and create them
-  for (map <std::string, TextMenu *>::iterator MenuRunner = NametoTextMenuMap.begin(); MenuRunner != NametoTextMenuMap.end(); ++MenuRunner) {
-    cout << "Creating Menu " << MenuRunner->first << "." << endl;
+  for (map <std::string, TextMenu *>::iterator MenuRunner = NametoTextMenuMap.begin(); MenuRunner != NametoTextMenuMap.end(); ++MenuRunner)
     populateMenu(MenuRunner->second, MenuRunner->first);
-  }
 
   // Add status indicators etc...
@@ -110,9 +120,22 @@
 {
   for (std::string::const_iterator CharRunner = name.begin(); CharRunner != name.end(); ++CharRunner) {
-    if (ShortcutList.find(*CharRunner) == ShortcutList.end())
+    if (ShortcutList.find(*CharRunner) == ShortcutList.end()) {
+      ShortcutList.insert(*CharRunner);
       return *CharRunner;
+    }
   }
-  DoeLog(1) && (eLog() << Verbose(1) << "Could not find a suitable shortform for TextWindow::getSuitableShortForm()." << endl);
-  return ((char)(ShortcutList.size() % 10) + '0');
+  // if no letter matches, take digits
+  int i=0;
+  for (;i<10;++i) {
+    if (ShortcutList.find((char)i + '0') == ShortcutList.end())
+      break;
+  }
+  if (i != 10) {
+    ShortcutList.insert((char)i + '0');
+    return ((char)i + '0');
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "Could not find a suitable shortform for " << name << "." << endl);
+    return '#';
+  }
 }
 
@@ -121,8 +144,9 @@
   Action *ActionItem = NULL;
   set <char> ShortcutList;
+  // reserve 'q' for quit
+  ShortcutList.insert('q');
   // through all actions for this menu
   pair < multimap <std::string, std::string>::iterator, multimap <std::string, std::string>::iterator > MenuActions = MapOfActions::getInstance().MenuContainsActionMap.equal_range(MenuName);
   for (multimap <std::string, std::string>::const_iterator MenuRunner = MenuActions.first; MenuRunner != MenuActions.second; ++MenuRunner) {
-    cout << " Adding " << MenuRunner->second << " to submenu " << MenuName << endl;
     ActionItem = ActionRegistry::getInstance().getActionByName(MenuRunner->second);
     new ActionMenuItem(getSuitableShortForm(ShortcutList, MenuRunner->second),MapOfActions::getInstance().getDescription(MenuRunner->second).c_str(),Menu,ActionItem);
Index: src/UIElements/UIFactory.cpp
===================================================================
--- src/UIElements/UIFactory.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/UIElements/UIFactory.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * UIFactory.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Views/QT4/GLMoleculeView.cpp
===================================================================
--- src/UIElements/Views/QT4/GLMoleculeView.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/UIElements/Views/QT4/GLMoleculeView.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * GLMoleculeView.cpp
@@ -6,5 +13,12 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "GLMoleculeView.hpp"
+
+#include "Helpers/MemDebug.hpp"
 
 GLMoleculeView::GLMoleculeView(QWidget *parent) :
Index: src/UIElements/Views/QT4/QTMoleculeView.cpp
===================================================================
--- src/UIElements/Views/QT4/QTMoleculeView.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/UIElements/Views/QT4/QTMoleculeView.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * QTMoleculeView.cpp
@@ -6,9 +13,16 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Views/QT4/QTMoleculeView.hpp"
 
 #include <iostream>
+
+#include "Helpers/MemDebug.hpp"
+
 #include "molecule.hpp"
-
 
 using namespace std;
Index: src/UIElements/Views/QT4/QTStatusBar.cpp
===================================================================
--- src/UIElements/Views/QT4/QTStatusBar.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/UIElements/Views/QT4/QTStatusBar.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * QTStatusBar.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include <sstream>
@@ -13,6 +25,9 @@
 
 #include "QTStatusBar.hpp"
+
+#include "Helpers/MemDebug.hpp"
+
 #include "World.hpp"
-#include "helpers.hpp"
+#include "Helpers/helpers.hpp"
 #include "Actions/Process.hpp"
 
@@ -21,7 +36,7 @@
   QStatusBar(_parent),
   Observer("QTStatusBar"),
-  parent(_parent),
   atomCount(World::getInstance().numAtoms()),
-  moleculeCount(World::getInstance().numMolecules())
+  moleculeCount(World::getInstance().numMolecules()),
+  parent(_parent)
 {
   World::getInstance().signOn(this);
Index: src/UIElements/Views/QT4/QTWorldView.cpp
===================================================================
--- src/UIElements/Views/QT4/QTWorldView.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/UIElements/Views/QT4/QTWorldView.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * QTWorldView.cpp
@@ -6,9 +13,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Views/QT4/QTWorldView.hpp"
 
 #include <iostream>
 
+#include "Helpers/MemDebug.hpp"
+
 #include "atom.hpp"
+#include "Formula.hpp"
 #include "molecule.hpp"
 
@@ -20,5 +35,5 @@
 // these attributes are skiped so far
 const int QTWorldView::COLUMNCOUNT = COLUMNTYPES_MAX;
-const char *QTWorldView::COLUMNNAMES[QTWorldView::COLUMNCOUNT]={"Name","Atoms"/*,"Formula"*/,"Center"/*,"Size"*/};
+const char *QTWorldView::COLUMNNAMES[QTWorldView::COLUMNCOUNT]={"Name","Atoms","Formula"/*,"Size"*/};
 
 QTWorldView::QTWorldView(QWidget * _parent) :
@@ -61,8 +76,5 @@
     const int index = (*iter)->IndexNr;
     QTableWidgetItem *indexWidget = new QTableWidgetItem();
-    // there probably is an easier method to convert ints to QStrings... but i didn't find it
-    stringstream idxsstr;
-    idxsstr << index;
-    indexWidget->setText(QString(idxsstr.str().c_str()));
+    indexWidget->setText(QString::number(index));
     indexWidget->setData(Qt::UserRole,QVariant(index));
     setVerticalHeaderItem(i,indexWidget);
@@ -75,17 +87,13 @@
     const int atomCount = (*iter)->getAtomCount();
     QTableWidgetItem *countWidget= new QTableWidgetItem();
-    stringstream countsstr;
-    countsstr << atomCount;
-    countWidget->setText(QString(countsstr.str().c_str()));
+    countWidget->setText(QString::number(atomCount));
     countWidget->setFlags(Qt::ItemIsSelectable | Qt::ItemIsUserCheckable | Qt::ItemIsEnabled);
     setItem(i,ATOMS,countWidget);
 
-    const Vector center = (*iter)->Center;
-    QTableWidgetItem *centerWidget = new QTableWidgetItem();
-    stringstream centersstr;
-    centersstr << center;
-    centerWidget->setText(QString(centersstr.str().c_str()));
-    setItem(i,CENTER,centerWidget);
-    centerWidget->setFlags(Qt::ItemIsSelectable | Qt::ItemIsUserCheckable | Qt::ItemIsEnabled);
+    const Formula formula = (*iter)->getFormula();
+    QTableWidgetItem *formulaWidget= new QTableWidgetItem();
+    formulaWidget->setText(QString(formula.toString().c_str()));
+    formulaWidget->setFlags(Qt::ItemIsSelectable | Qt::ItemIsUserCheckable | Qt::ItemIsEnabled);
+    setItem(i,ATOMS,formulaWidget);
 
     molSelection[i]=nameWidget->isSelected();
Index: src/UIElements/Views/QT4/QTWorldView.hpp
===================================================================
--- src/UIElements/Views/QT4/QTWorldView.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/UIElements/Views/QT4/QTWorldView.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -28,5 +28,5 @@
 
   static const int COLUMNCOUNT;
-  enum {NAME,ATOMS,CENTER,COLUMNTYPES_MAX} COLUMNTYPES;
+  enum {NAME,ATOMS,FORMULA,COLUMNTYPES_MAX} COLUMNTYPES;
   static const char *COLUMNNAMES[];
 
Index: src/UIElements/Views/StreamStringView.cpp
===================================================================
--- src/UIElements/Views/StreamStringView.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/UIElements/Views/StreamStringView.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * StreamStringView.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -16,6 +28,6 @@
 
 StreamStringView::StreamStringView(boost::function<void(ostream *)> _displayMethod) :
-StringView(),
-displayMethod(_displayMethod)
+  StringView(),
+  displayMethod(_displayMethod)
 {}
 
Index: src/UIElements/Views/StringView.cpp
===================================================================
--- src/UIElements/Views/StringView.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/UIElements/Views/StringView.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * StringView.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Views/View.cpp
===================================================================
--- src/UIElements/Views/View.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/UIElements/Views/View.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * View.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/World.cpp
===================================================================
--- src/World.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/World.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * World.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -25,5 +37,5 @@
 #include "Helpers/Assert.hpp"
 #include "Box.hpp"
-#include "Matrix.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 #include "defs.hpp"
 
@@ -32,4 +44,7 @@
 
 using namespace std;
+
+const unsigned int MAX_POOL_FRAGMENTATION=20;
+const unsigned int MAX_FRAGMENTATION_SKIPS=100;
 
 /******************************* getter and setter ************************/
@@ -138,4 +153,5 @@
 void World::destroyMolecule(molecule* mol){
   OBSERVE;
+  ASSERT(mol,"Molecule that was meant to be destroyed did not exist");
   destroyMolecule(mol->getId());
 }
@@ -199,4 +215,25 @@
       atoms.erase(oldId);
       atoms.insert(pair<atomId_t,atom*>(newId,target));
+      return true;
+    }
+    else{
+      return false;
+    }
+  }
+}
+
+bool World::changeMoleculeId(moleculeId_t oldId, moleculeId_t newId, molecule* target){
+  OBSERVE;
+  // in case this call did not originate from inside the atom, we redirect it,
+  // to also let it know that it has changed
+  if(!target){
+    target = molecules[oldId];
+    ASSERT(target,"Molecule with that ID not found");
+    return target->changeId(newId);
+  }
+  else{
+    if(reserveMoleculeId(newId)){
+      molecules.erase(oldId);
+      molecules.insert(pair<moleculeId_t,molecule*>(newId,target));
       return true;
     }
@@ -701,4 +738,6 @@
     selectedMolecules(this),
     currMoleculeId(0),
+    lastMoleculePoolSize(0),
+    numMoleculeDefragSkips(0),
     molecules_deprecated(new MoleculeListClass(this))
 {
@@ -718,7 +757,4 @@
   delete cell_size;
   delete molecules_deprecated;
-  delete periode;
-  delete configuration;
-  delete Thermostats;
   MoleculeSet::iterator molIter;
   for(molIter=molecules.begin();molIter!=molecules.end();++molIter){
@@ -731,4 +767,7 @@
   }
   atoms.clear();
+  delete periode;
+  delete configuration;
+  delete Thermostats;
 }
 
@@ -736,4 +775,8 @@
 
 CONSTRUCT_SINGLETON(World)
+
+CONSTRUCT_OBSERVEDCONTAINER(World::AtomSTLSet)
+
+CONSTRUCT_OBSERVEDCONTAINER(World::MoleculeSTLSet)
 
 /******************************* deprecated Legacy Stuff ***********************/
Index: src/World.hpp
===================================================================
--- src/World.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/World.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -72,8 +72,11 @@
 template<typename> friend class AtomsCalculation;
 public:
+  // some typedefs for the CONSTRUCT_... macros (no "," allows in a single parameter name)
+  typedef std::map<atomId_t,atom*> AtomSTLSet;
+  typedef std::map<moleculeId_t,molecule*> MoleculeSTLSet;
 
   // Types for Atom and Molecule structures
-  typedef ObservedContainer<std::map<atomId_t,atom*> > AtomSet;
-  typedef ObservedContainer<std::map<moleculeId_t,molecule*> > MoleculeSet;
+  typedef ObservedContainer< AtomSTLSet > AtomSet;
+  typedef ObservedContainer< MoleculeSTLSet > MoleculeSet;
 
   typedef ATOMSET(std::vector) AtomComposite;
@@ -217,4 +220,12 @@
    */
   bool changeAtomId(atomId_t oldId, atomId_t newId, atom* target=0);
+
+  /**
+   * used when changing an molecule Id.
+   * Unless you are calling this method from inside an moleucle don't fiddle with the third parameter.
+   *
+   * Return value indicates wether the change could be done or not.
+   */
+  bool changeMoleculeId(moleculeId_t oldId, moleculeId_t newId, molecule* target=0);
 
   /**
